function [K,S,P] = lqr_toragi(A,B,Q,R)
    n=length(A);
    H=[A -B*inv(R)*B';-Q -A'];
    [v,p] = eig(H);
    stable_index=find(real(diag(p))<0);
    f=v(1:n,stable_index);
    g=v((1+n):(2*n),stable_index);
    S=real(g*inv(f));
    K=inv(R)*B'*S;
    P=diag(p(stable_index,stable_index));
end
